<?php
namespace Litematrimony\Profile\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Notifications\Messages\MailMessage;
use Illuminate\Notifications\Notification;
use Litematrimony\Profile\Events\RequestAction as RequestActionEvent;
use Litematrimony\Profile\Models\Request;

class RequestAction extends Notification implements ShouldQueue
{
    use Queueable;

    protected $request;

    protected $action;

    /**
     * Create a new notification instance.
     *
     * @param RequestActionEvent $request
     * @param string $action
     */
    public function __construct(RequestActionEvent $request, string $action)
    {
        $this->action = $action;
        $this->request = $request;
    }

    /**
     * Get the mail representation of the notification.
     *
     * @param mixed $notifiable
     * @return \Illuminate\Notifications\Messages\MailMessage
     */
    public function toMail($notifiable)
    {
        return (new MailMessage)
            ->subject('Request Approved - ' . config('app.name'))
            ->view('profile::request.email.action', ['data' => $this->request]);
    }

    /**
     * Get the notification's delivery channels.
     *
     * @param object $notifiable
     * @return array<int, string>
     */
    public function via(object $notifiable): array
    {
        return ['mail'];
    }
}
